<template>
  <div class="rui-collapsible-list-item" :class="showContent ? 'rui-collapsible-list-item--active' : ''">
    <div class="rui-list-item">
      <div class="rui-list-item__content" @click="showContent = !showContent">
        <slot name="caption">
          <div role="button" class="rui-list-item__title">
            <span>{{ caption }}</span>
          </div>
        </slot>
      </div>

      <div v-if="$slots.actions" class="rui-list-item__actions">
        <rui-toolbar>
          <!-- @slot Right toolbar content -->
          <slot name="actions" />
        </rui-toolbar>
      </div>
    </div>
    <div class="rui-collapsible-list-item__content">
      <slot />
    </div>
  </div>
</template>
<script>
import RuiToolbar from '../Toolbar/Toolbar.vue'

/**
 * Meant to be used in a list of things, this component has collapsible content.
 *
 * @preset default {
 *                   "props": { "caption": "My item" },
 *                   "slots": {
 *                     "default": "Item content",
 *                     "actions": "<button class=\"rui-button rui-button--creative\">Edit</button>"
 *                   }
 *                 }
 */
export default {
  name: 'RuiCollapsibleListItem',
  components: { RuiToolbar },
  props: {
    /** Main text */
    caption: { required: false, type: String, default: null },
  },
  data () {
    return {
      showContent: false,
    }
  },
}
</script>
